All Classes Namespaces Functions Pages
hal::BottomSegment Class Referenceabstract

`#include <halBottomSegment.h>`

Inheritance diagram for hal::BottomSegment:

## Public Member Functions

virtual hal_size_t | getNumChildren () const =0
virtual hal_index_t | getChildIndex (hal_size_t i) const =0
virtual hal_index_t | getChildIndexG (const Genome *childGenome) const =0
virtual bool | hasChild (hal_size_t child) const =0
virtual bool | hasChildG (const Genome *childGenome) const =0
virtual void | setChildIndex (hal_size_t i, hal_index_t childIndex)=0
virtual bool | getChildReversed (hal_size_t i) const =0
virtual void | setChildReversed (hal_size_t child, bool isReversed)=0
virtual hal_index_t | getTopParseIndex () const =0
virtual void | setTopParseIndex (hal_index_t parseIndex)=0
virtual hal_offset_t | getTopParseOffset () const =0
virtual bool | hasParseUp () const =0
virtual hal_index_t | getLeftChildIndex (hal_size_t i) const =0
virtual hal_index_t | getRightChildIndex (hal_size_t i) const =0
Public Member Functions inherited from hal::Segment
virtual void | setArrayIndex (Genome *genome, hal_index_t arrayIndex)=0
virtual void | setArrayIndex (const Genome *genome, hal_index_t arrayIndex) const =0
virtual const Genome * | getGenome () const =0
virtual Genome * | getGenome ()=0
virtual const Sequence * | getSequence () const =0
virtual Sequence * | getSequence ()=0
virtual hal_index_t | getStartPosition () const =0
virtual hal_index_t | getEndPosition () const =0
virtual hal_size_t | getLength () const =0
virtual void | getString (std::string &outString) const =0
virtual void | setCoordinates (hal_index_t startPos, hal_size_t length)=0
virtual hal_index_t | getArrayIndex () const =0
virtual bool | leftOf (hal_index_t genomePos) const =0
virtual bool | rightOf (hal_index_t genomePos) const =0
virtual bool | overlaps (hal_index_t genomePos) const =0
virtual bool | isFirst () const =0
virtual bool | isLast () const =0
virtual bool | isMissingData (double nThreshold) const =0
virtual bool | isTop () const =0
virtual hal_size_t | getMappedSegments (std::set< MappedSegmentConstPtr > &outSegments, const Genome *tgtGenome, const std::set< const Genome * > *genomesOnPath=NULL, bool doDupes=true, hal_size_t minLength=0) const =0
virtual void | print (std::ostream &os) const =0

## Friends

class | counted_ptr< BottomSegment >
class | counted_ptr< const BottomSegment >

## Detailed Description

Interface for a bottom segment of DNA

## Member Function Documentation

virtual hal_index_t hal::BottomSegment::getChildIndex | ( | hal_size_t | i | ) | const

pure virtual

Get the index of a child segment (OR NULL_INDEX if none)

Parameters

  i | index of child to query

virtual hal_index_t hal::BottomSegment::getChildIndexG | ( | const Genome * | childGenome | ) | const

pure virtual

Get the index of a child segment (OR NULL_INDEX if none)

Parameters

  childGenome | genome of child to query

virtual bool hal::BottomSegment::getChildReversed | ( | hal_size_t | i | ) | const

pure virtual

Get whether descent segment for ith child is mapped to the reverse complement of this segment

Parameters

  i | index of child to query

virtual hal_index_t hal::BottomSegment::getLeftChildIndex | ( | hal_size_t | i | ) | const

pure virtual

Get the index of the child of the left neighbour of this segment in the genome (use isLeft first to check if the left neighbour is in the same sequence)

Parameters

  i | index of child genome to query

virtual hal_size_t hal::BottomSegment::getNumChildren | ( |  | ) | const

pure virtual

Get the number of child genomes (note this is a number of slots and that the current segment could actually have fewer children)

virtual hal_index_t hal::BottomSegment::getRightChildIndex | ( | hal_size_t | i | ) | const

pure virtual

Get the right of the child of the left neighbour of this segment in the genome (use isRight first to check if the right neighbour is in the same sequence)

Parameters

  i | index of child genome to query

virtual hal_index_t hal::BottomSegment::getTopParseIndex | ( |  | ) | const

pure virtual

Get index of top segment in samge genome that contains this segment's start coordinate

virtual hal_offset_t hal::BottomSegment::getTopParseOffset | ( |  | ) | const

pure virtual

Get offset in associated top segment of start coordinate of this segment

virtual bool hal::BottomSegment::hasChild | ( | hal_size_t | child | ) | const

pure virtual

Test if child segment exists

Parameters

  child | index of child genome

virtual bool hal::BottomSegment::hasChildG | ( | const Genome * | childGenome | ) | const

pure virtual

Test if child segment exists

Parameters

  child | Child genome

virtual bool hal::BottomSegment::hasParseUp | ( |  | ) | const

pure virtual

Test if there is a top parse segment in the genome that contains the start positon of the current iterator (should be true if not in root

virtual void hal::BottomSegment::setChildIndex | ( | hal_size_t | i,
|  | hal_index_t | childIndex
| ) |  |

pure virtual

Set the index of a child segment (OR NULL_INDEX if none)

Parameters

  i | index of child to set
  childIndex | index of segment in child to set

virtual void hal::BottomSegment::setChildReversed | ( | hal_size_t | child,
|  | bool | isReversed
| ) |  |

pure virtual

Set whether descent segment for ith child is mapped to the reverse complement of this segment

Parameters

  i | index of child to set
  isReverse | flag

virtual void hal::BottomSegment::setTopParseIndex | ( | hal_index_t | parseIndex | ) |

pure virtual

Set index of top segment in samge genome that contains this segment's start coordinate

Parameters

  parParseIndex | index

The documentation for this class was generated from the following file:

- inc/halBottomSegment.h